﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace BitmapTagger
{
	/// <summary>
	/// Contains the UIDs of the Exif tags in use
	/// </summary>
	public static class JpegExifIDs
	{
		/// <summary>
		/// ID for the image width tag
		/// </summary>
		public const uint ImageWidthID = 256;

		/// <summary>
		/// ID for the image height tag
		/// </summary>
		public const uint ImageHeightID = 257;

		/// <summary>
		/// ID for the bits per sample tag
		/// </summary>
		public const uint BitsPerSampleID = 258;

		/// <summary>
		/// ID for the compression type tag
		/// </summary>
		public const uint CompressionID = 259;

		/// <summary>
		/// ID for the photometric interpretation tag
		/// </summary>
		public const uint PhotometricInterpretationID = 262;

		/// <summary>
		/// ID for the X resolution tag
		/// </summary>
		public const uint XResolutionID = 282;

		/// <summary>
		/// ID for the Y resolution tag
		/// </summary>
		public const uint YResolutionID = 283;

		/// <summary>
		/// ID for the resolution unit tag
		/// </summary>
		public const uint ResolutionUnitID = 296;

		/// <summary>
		/// ID for the date time tag
		/// </summary>
		public const uint DateTimeID = 306;

		/// <summary>
		/// ID for the image description tag
		/// </summary>
		public const uint ImageDescriptionID = 270;

		/// <summary>
		/// ID for the make tag
		/// </summary>
		public const uint MakeID = 271;

		/// <summary>
		/// ID for the model tag
		/// </summary>
		public const uint ModelID = 272;

		/// <summary>
		/// ID for the software tag
		/// </summary>
		public const uint SoftwareID = 305;

		/// <summary>
		/// ID for the artist tag
		/// </summary>
		public const uint ArtistID = 315;

		/// <summary>
		/// ID for the Copyright tag
		/// </summary>
		public const uint CopyrightID = 33432;

		/// <summary>
		/// ID for the user comment
		/// </summary>
		public const uint UserCommentID = 37510;

		/// <summary>
		/// ID for DateTime Original Data generated
		/// </summary>
		public const uint DateTimeOriginalID = 36867;

		/// <summary>
		/// ID for DateTime data digitized
		/// </summary>
		public const uint DateTimeDigitizedID = 36868;

		/// <summary>
		/// ID for the Metering Mode Used
		/// </summary>
		public const uint MeteringModeID = 37383;

		/// <summary>
		/// ID for Manufactuer Note
		/// </summary>
		public const uint MakerNoteID = 37500;

		/// <summary>
		/// ID for Sensing Method
		/// </summary>
		public const uint SensingMethodID = 41495;

		/// <summary>
		/// ID for Exposure Program
		/// </summary>
		public const uint ExposureProgramID = 34850;

		/// <summary>
		/// ID for ISO Speed Ratings
		/// </summary>
		public const uint ISOSpeedRatingsID = 34855;

		/// <summary>
		/// ID for the Light Source
		/// </summary>
		public const uint LightSourceID = 37384;

		/// <summary>
		/// ID for the Exposure Time
		/// </summary>
		public const uint ExposureTimeID = 33434;

		/// <summary>
		/// ID for the FNumber
		/// </summary>
		public const uint FNumberID = 33437;

		/// <summary>
		/// ID for the Shutter Speed
		/// </summary>
		public const uint ShutterSpeedID = 37377;

		/// <summary>
		/// ID for Aperture
		/// </summary>
		public const uint ApertureID = 37378;

		/// <summary>
		/// ID for Brightness
		/// </summary>
		public const uint BrightnessID = 37379;

	}
}
