﻿namespace BitmapTagger
{
	/// <summary>
	/// The order or precedence for the tagging system.
	/// </summary>
	/// <remarks>
	/// XMPExif referes to XMP tags with the Exif scheme
	/// </remarks>
	public enum TagPrecedence
	{
		/// <summary>
		/// Exif then XMPExif then XMP
		/// </summary>
		Exif_XMPExif_XMP,

		/// <summary>
		/// Exif thetn XMP then XMPExif
		/// </summary>
		Exif_XMP_XMPExif,

		/// <summary>
		/// XMP then XMPExif then Exif
		/// </summary>
		XMP_XMPExif_Exif,

		/// <summary>
		/// XMP then Exif then XMPExif
		/// </summary>
		XMP_Exif_XMPExif,

		/// <summary>
		/// XMPExif then Exif then XMP
		/// </summary>
		XMPExif_Exif_XMP,

		/// <summary>
		/// XMPExif then XMP then Exif
		/// </summary>
		XMPExif_XMP_Exif

	}

}