﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml.Linq;

namespace BitmapTagger
{
	/// <summary>
	/// Contains the names for the basic XMP elements
	/// </summary>
	public static class XMPElementNames
	{
		/// <summary>
		/// Element name for XMP Metadata element 
		/// </summary>
		/// <remarks>
		/// The outermost element
		/// </remarks>
		public static XName Metadata = XMPNamespaces.MetadataNamespace + "xmpmeta";

		/// <summary>
		/// Element name for RDF element name 
		/// </summary>
		/// <remarks>
		/// Normally the second outermost element, but possibly outermost element
		/// </remarks>
		public static XName RDF = XMPNamespaces.RDFNamespace + "RDF";

		/// <summary>
		/// Element name for description element 
		/// </summary>
		/// <remarks>
		/// This element is where the tag elements go
		/// </remarks>
		public static XName Description = XMPNamespaces.RDFNamespace + "Description";
	}
}
