﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml.Linq;

namespace BitmapTagger
{
	/// <summary>
	/// Contains the XMP Namespace prefixes for the XMP tags in use
	/// </summary>
	public static class XMPPrefixes
	{

		/// <summary>
		/// Prefix for the Dublin Core Schema
		/// </summary>
		public const string DublinCorePrefix = "dc";

		/// <summary>
		/// Prefix for the XMP Basic Schema
		/// </summary>
		public const string XMPBasicPrefix = "xmp";

		/// <summary>
		/// Prefix for the XMP Rights Schema
		/// </summary>
		public const string XMPRightsPrefix = "xmpRights ";

		/// <summary>
		/// Schema namespace for the Tiff Exif Schema
		/// </summary>
		public const string TiffExifPrefix = "tiff";

		/// <summary>
		/// Prefix for the Exif schema
		/// </summary>
		public const string ExifPrefix = "exif";

		/// <summary>
		/// Prefix for the Metadata namespace (outermost element)
		/// </summary>
		public const string MetadataPrefix = "x";

		/// <summary>
		/// Prefix for the RDF namespace elements
		/// </summary>
		public const string RDFPrefix = "rdf";
	}
}
