﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml.Linq;

namespace BitmapTagger
{
	/// <summary>
	/// Contains the tag IDs (names) for the XMP tags (not the XMPExif tags)
	/// </summary>
	public static class XMPTagIDs
	{
		/// <summary>
		/// ID for the modify date tags
		/// </summary>
		public static XName ModifyDateID = XMPNamespaces.XMPBasicSchema +  "ModifyDate";

		/// <summary>
		/// ID for the description tag
		/// </summary>
		public static XName DescriptionID = XMPNamespaces.DublinCoreSchema + "description";

		/// <summary>
		/// ID for the creator tool tag
		/// </summary>
		public static XName CreatorToolID = XMPNamespaces.XMPBasicSchema + "CreatorTool";

		/// <summary>
		/// ID for the creator tag
		/// </summary>
		public static XName CreatorID = XMPNamespaces.DublinCoreSchema + "creator";

		/// <summary>
		/// ID for the rights tag
		/// </summary>
		public static XName RightsID = XMPNamespaces.DublinCoreSchema + "rights";

		/// <summary>
		/// ID for a XMP lang alt element
		/// </summary>
		public static XName LangAltID = XMPNamespaces.RDFNamespace + "Alt";

		/// <summary>
		/// ID for a XMP list element
		/// </summary>
		public static XName ListElementID = XMPNamespaces.RDFNamespace + "li";

		///ID of for a language atttibute (used in lang alt)
		public static XName LanguageID = XNamespace.Xml + "lang";


	}
}
