﻿// Original author contact info: Owen Emlen (owene_1998@yahoo.com)
// Note: other individuals may also have contributed to this code
// Project hosted on CodePlex.com as of 1/10/2009 at http://wpfimageviewer.codeplex.com/EmlenMud
using System;
using System.ComponentModel;
using BrainTechLLC;
using System.Drawing;
using System.IO;
using System.Threading;
using BrainTechLLC.WPF;
using System.Diagnostics;
using System.Drawing.Imaging;
using BrainTechLLC.BaseLibrary;
using System.Windows.Media;

namespace BrainTechLLC.ImageOperatorsNonAForgeDependent
{
    public static class Helpers
    {
        public static ImageSource LoadImageSource(this Bitmap bitmap, byte[] bytes)
        {
            ImageSource imgSource = null;
            try
            {
                imgSource = ImageSourceCreation.CreateImageSourceFromBitmap(bitmap, bytes);
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.ToString());
            }
            return imgSource;
        }

        public static Bitmap ReadBitmapFromByteStream(this byte[] bytes)
        {
            return Image.FromStream(new MemoryStream(bytes), true, false) as Bitmap;
        }

        public static Bitmap ResizeBitmap(this Bitmap img, int oldWidth, int oldHeight, int newWidth, int newHeight, RenderSettings settings, bool maintainAspectRatio = true)
        {
            if (oldWidth == newWidth && oldHeight == newHeight)
                // Untested path
                return img.Clone() as Bitmap;
            else
                return img.CreateBitmap(oldWidth, oldHeight, newWidth, newHeight, maintainAspectRatio, settings);
        }
    }
}
