﻿// Original author contact info: Owen Emlen (owene_1998@yahoo.com)
// Note: other individuals may also have contributed to this code
// Project hosted on CodePlex.com as of 1/10/2009 at http://wpfimageviewer.codeplex.com
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Reflection;
using System.Windows;
using BrainTechLLC;

namespace ImageAppViewModels
{ 
    public class EventCallInfoViewModel : BaseNotifyPropertyChanged
    {
        public EventCallInfo _info;
        public Type _objectInstanceType;
        public object _objectInstance;

        public EventCallInfoViewModel(EventCallInfo info, object objectInstance, Type objectInstanceType)
        {
            _objectInstance = objectInstance;
            _objectInstanceType = objectInstanceType;
            _info = info;
        }

        public Type ObjectInstanceType
        {
            get { return _objectInstanceType; }
        }

        public object ObjectInstance
        {
            get { return _objectInstance; }
        }

        public string ObjectInstanceTypeName
        {
            get { return _objectInstanceType == null ? "null" : _objectInstanceType.Name; }
        }

        public string ObjectInstanceName
        {
            get { return _objectInstance == null ? "null" : _objectInstance.ToString(); }
        }

        public Type EventArgsType
        {
            get { return _info.EventArgsType; }
        }

        public string EventArgsTypeName
        {
            get { return _info.EventArgsType.Name; }
        }

        public string TargetName
        {
            get { return _info.Target == null ? string.Empty : _info.Target.ToString(); }
        }

        public object Target
        {
            get { return _info.Target; }
        }

        public Type TargetType
        {
            get { return _info.TargetType; }
        }

        public MethodInfo TargetMethod
        {
            get { return _info.TargetMethod; }
        }

        public string TargetTypeName
        {
            get { return TargetType == null ? "Static" : _info.TargetType.Name; }
        }

        public Visibility PropChangedVisibility
        {
            get { return (typeof(PropertyChangedEventArgs).IsAssignableFrom(EventArgsType)) ? Visibility.Visible : Visibility.Collapsed; }
        }

        public string PropertyValueAtTime
        {
            get { return _info.PropertyValueAtTime == null ? "null" : _info.PropertyValueAtTime.ToString(); }
        }

        public string PropertyName
        {
            get { return _info.AdditionalInfo as string; }
        }

        public string TargetMethodName
        {
            get { return _info.TargetMethod.Name; }
        }
    }


}
